Attribute VB_Name = "Module1"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

Public Type ID3TagV2
    Version As String
    TagLength As Long
    ExtendedHeader As Boolean
    PlayCounter As Long
    Track As Long
    Encoder As String
    Link As String
    Copyright As String
    OriginalArtist As String
    Composer As String
    Genre As String
    Comment As String
    Year As String
    Album As String
    Artist As String
    Title As String
    Language As String
    Length As Long
    MediaType As String
    Publisher As String
    DecodingSoftware As String
    UnknownFrames As Long
End Type

Public Function GetID3TagV2(ByVal MP3FileName As String, _
    ID3Tag As ID3TagV2) As Boolean
    
    Dim Mp3FileNumber, Mp3FileContent As String
    Dim ID3Position As Long, ID3Length As String, lngID3Length As Long
    Dim ID3Version As String, ID3V2Tag As String
    
    On Error Resume Next
    
    If Len(Dir(MP3FileName)) = 0 Then
        GetID3TagV2 = False
        Exit Function
    End If
    
    If LCase(Right(MP3FileName, 4)) <> ".mp3" Then
        GetID3TagV2 = False
        Exit Function
    End If
    
    Mp3FileNumber = FreeFile
    
    'MP3 einlesen...
    Open MP3FileName For Binary As Mp3FileNumber
    Mp3FileContent = String$(LOF(Mp3FileNumber), "!")
    Get Mp3FileNumber, , Mp3FileContent
    Close Mp3FileNumber
    
    'ID3V2-Tag suchen
    ID3Position = InStr(Mp3FileContent, "ID3")
    If ID3Position = 0 Then
        GetID3TagV2 = False
        Exit Function
    End If
    
    'Tag gefunden, weiter gehts!
    ID3Version = Mid$(Mp3FileContent, ID3Position + 3, 2)
    
    'Versionkontrolle
    If Asc(Left$(ID3Version, 1)) <> 2 And Asc(Left$(ID3Version, 1)) <> 3 And _
        Asc(Left$(ID3Version, 1)) <> 4 Then
        
        GetID3TagV2 = False
        Exit Function
    End If
    
    'Version anzeigen
    ID3Tag.Version = Str$(Asc(Left$(ID3Version, 1))) & "." & Trim$(Str$(Asc(Right$(ID3Version, 1))))
    
    'Lnge bestimmen
    ID3Length = Mid$(Mp3FileContent, ID3Position + 6, 4)
    
    'lngID3Length = 256 * 8 * 8 * Asc(Left$(ID3Length, 1)) + 256 * 8 * Asc(Mid$(ID3Length, _
             2, 1)) + 256 * Asc(Mid$(ID3Length, 3, 1)) + Asc(Mid$(ID3Length, 4, 1))
    
    
    lngID3Length = &H200000 * Asc(Left$(ID3Length, 1)) + &H4000 * Asc(Mid$(ID3Length, _
        2, 1)) + &H80 * Asc(Mid$(ID3Length, 3, 1)) + Asc(Mid$(ID3Length, 4, 1))
    
    
    'Lnge ausgeben
    ID3Tag.TagLength = lngID3Length
    
    ID3V2Tag = Mid$(Mp3FileContent, ID3Position, lngID3Length + 10)
    
    Mp3FileContent = ""
    
    'Nach Extended Header suchen...
    If (Asc(Mid$(ID3V2Tag, 6, 1)) And 32) = 32 Then
        ID3Tag.ExtendedHeader = True
        ID3V2Tag = Mid$(ID3V2Tag, 10)
    End If
    ID3V2Tag = Mid$(ID3V2Tag, 11)
    
    'Nun Frame fr Frame abarbeiten...
    Dim FrameName As String, FrameLen As String
    Dim FrameFlags As String, Frame As String
    Dim lngFrameLen As Long
    
    ID3Tag.UnknownFrames = 0
    
    Do
        
        'ID3V2.3
        If Asc(Left$(ID3Version, 1)) = 3 Or Asc(Left$(ID3Version, 1)) = 4 Then
            
            'Frame-Header auslesen
            FrameName = Left$(ID3V2Tag, 4)
            
            'Wenn es sich um den Footer handelt, dann sind wir
            'fertig!
            If Left$(FrameName, 3) = "3DI" Then Exit Do
            FrameLen = Mid$(ID3V2Tag, 5, 4)
            lngFrameLen = 256 * 8 * 8 * Asc(Left$(FrameLen, 1)) + 256 * 8 * Asc(Mid$(FrameLen, _
                2, 1)) + 256 * Asc(Mid$(FrameLen, 3, 1)) + Asc(Mid$(FrameLen, 4, 1))
            
            
            
            FrameFlags = Mid$(ID3V2Tag, 9, 2)
            ID3V2Tag = Mid$(ID3V2Tag, 11)
            
            'Frame-Content bestimmen
            Select Case FrameName
            Case "PCNT"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.PlayCounter = Val(Mid$(ID3V2Tag, 2, lngFrameLen - 1))
                Else
                    ID3Tag.PlayCounter = Val(Left$(ID3V2Tag, lngFrameLen))
                End If
                
            Case "TRCK"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Track = Val(Mid$(ID3V2Tag, 2, lngFrameLen - 1))
                Else
                    ID3Tag.Track = Val(Left$(ID3V2Tag, lngFrameLen))
                End If
                
            Case "TENC"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Encoder = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Encoder = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "WXXX"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Link = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Link = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TCOP"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Copyright = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Copyright = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TOPE"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.OriginalArtist = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.OriginalArtist = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TCOM"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Composer = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Composer = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TCON"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Genre = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Genre = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "COMM"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Comment = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Comment = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TYER"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Year = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Year = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TALB"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Album = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Album = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TPE1"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Artist = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Artist = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TIT2"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Title = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Title = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TLAN"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Language = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Language = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TLEN"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Length = Val(Mid$(ID3V2Tag, 2, lngFrameLen - 1))
                Else
                    ID3Tag.Length = Val(Left$(ID3V2Tag, lngFrameLen))
                End If
                
            Case "TMED"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.MediaType = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.MediaType = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TPUB"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Publisher = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Publisher = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TSSE"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.DecodingSoftware = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.DecodingSoftware = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case Else
                ID3Tag.UnknownFrames = ID3Tag.UnknownFrames + 1
            End Select
            
            ID3V2Tag = Mid$(ID3V2Tag, lngFrameLen + 1)
            
            'ID3V2.2
        ElseIf Asc(Left$(ID3Version, 1)) = 2 Then
            
            'Frame-Header auslesen
            FrameName = Left$(ID3V2Tag, 3)
            
            'Wenn es sich um den Footer handelt, dann sind wir
            'fertig!
            If FrameName = "3DI" Then Exit Do
            FrameLen = Mid$(ID3V2Tag, 4, 3)
            lngFrameLen = 256 * 8 * Asc(Left$(FrameLen, 1)) + 256 * Asc(Mid$(FrameLen, 2, _
                1)) + Asc(Mid$(FrameLen, 3, 1))
            
            
            
            ID3V2Tag = Mid$(ID3V2Tag, 7)
            
            'Frame-Content bestimmen
            Select Case FrameName
            Case "TRK"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Track = Val(Mid$(ID3V2Tag, 2, lngFrameLen - 1))
                Else
                    ID3Tag.Track = Val(Left$(ID3V2Tag, lngFrameLen))
                End If
                
            Case "TEN"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Encoder = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Encoder = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TCR"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Copyright = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Copyright = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TOA"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.OriginalArtist = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.OriginalArtist = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TCM"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Composer = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Composer = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TCO"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Genre = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Genre = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "COM"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Comment = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Comment = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TYE"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Year = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Year = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TAL"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Album = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Album = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TP1"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Artist = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Artist = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TT2"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Title = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Title = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TLA"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.Language = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.Language = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TMT"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.MediaType = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.MediaType = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case "TSS"
                If Left$(ID3V2Tag, 1) = Chr$(0) Then
                    ID3Tag.DecodingSoftware = Mid$(ID3V2Tag, 2, lngFrameLen - 1)
                Else
                    ID3Tag.DecodingSoftware = Left$(ID3V2Tag, lngFrameLen)
                End If
                
            Case Else
                ID3Tag.UnknownFrames = ID3Tag.UnknownFrames + 1
            End Select
            
            ID3V2Tag = Mid$(ID3V2Tag, lngFrameLen + 1)
            
        End If
        
    Loop Until Len(ID3V2Tag) = 0
    
    GetID3TagV2 = True
End Function
